//
//
//		form-bug-2001-03-18 
//		2001-03-18 Stefan Vogtner
//		
//		this program leaks memory (40 kB/s@166 MHz)
//
#include <iostream>
#include <fstream>
#include <string>
#include <strstream>
#include <vector>

using namespace std;

#include <ncurses.h>
#include <form.h>

#include <unistd.h> // for sleep

typedef vector<vector<string> > VVS;
typedef vector<string> VS;

typedef VVS::const_iterator VVSCI;
typedef VS::const_iterator VSCI;

int getNumberOfLines (WINDOW *win)
{
	int yb, xb, ye, xe;
	getbegyx (win, yb, xb);
	getmaxyx (win, ye, xe);
	clog 
		<< "yb = " << yb 
		<< ", ye = " << ye 
		<< ", xb = " << xb 
		<< ", xe = " << xe 
		<< endl;
	return ye - yb + 1;
}

void step4 (FORM *form, VVSCI &Begin, VVSCI &End,
		vector<FIELD *> &fieldcontents) // noreturn
//
//		manage display of records: replace field buffer
//
{
	int rv;
	VVSCI current = Begin;
	vector<FIELD *>::iterator p;
	vector<string>::const_iterator q = current->begin ();
	for (p = fieldcontents.begin (); 
		p != fieldcontents.end (); ++p, ++q) {
		set_field_buffer (*p, 0, q->c_str ());
	}
	rv = wrefresh (form_win (form));
	if (rv != E_OK)
		throw __LINE__;

	WINDOW *www = form_win (form);

////////////////////////////////////////////////////////////////////////
//		before the leaking loop
//
	while (true) {
		form_driver (form, REQ_PREV_PAGE);
		wrefresh (www);
//		wrefresh (form_win (form));
	}
//
//		below the leaking loop
////////////////////////////////////////////////////////////////////////
}


void step3 (vector<string> &attributes, VVSCI &Begin, VVSCI &End,
		WINDOW *derw)
{
	int rv;
	vector<FIELD *> vaf;
	vector<FIELD *> fieldcontents;
	vector<string> attr_numbers;
	VSCI p;
	int toprow (0);
	int leftcol0 (0);
	int attr_count (0);
	int lines = getNumberOfLines (derw);

	lines = 2;

	clog << "lines = " << lines << endl;

	FIELD *f, *h [3];
	f = new_field (1, 5, toprow, leftcol0, 0, 1);
	set_field_buffer (f, 0, "#");
	field_opts_off (f, O_EDIT);
	field_opts_off (f, O_ACTIVE);
///	set_field_just (f, JUSTIFY_RIGHT);
	set_field_back (f, COLOR_PAIR (2));
	vaf.push_back (f);
	h[0] = f;


	toprow += 1;

	for (p = attributes.begin (); p != attributes.end (); ++p) {
//		clog << "toprow = " << toprow << endl;
		if (toprow >= lines) { // toprow count from 0, lines from 1
			                    // so use >=
			clog << "re-setting toprow to 0" << endl;
			toprow = 0;

			f = link_field (h [0], toprow, leftcol0);
			set_new_page (f, TRUE);
			vaf.push_back (f);

			toprow += 1;
		} 

		// attribute number
		
		f = new_field (1, 5, toprow, leftcol0, 0, 1);
		strstream tmp;
		tmp << ++attr_count << endl;
		string attribute_number;
		tmp >> attribute_number;
		attr_numbers.push_back (attribute_number);
		clog << "a num = " << attr_numbers.back () << endl;

		field_opts_off (f, O_EDIT);
		field_opts_off (f, O_ACTIVE);
////		set_field_just (f, JUSTIFY_RIGHT);
		set_field_buffer (f, 0, attr_numbers.back ().c_str ());
		set_field_back (f, COLOR_PAIR (3));
		vaf.push_back (f);


		toprow += 1;
	}


	size_t nfields = vaf.size ();
	FIELD **vvf = new FIELD* [nfields + 1];

	for (int i = 0; i < (int) nfields; ++i)
		vvf [i] = vaf [i];

	vvf [vaf.size ()] = 0;

	FORM *form = new_form (vvf);
	if (! form)
		throw __LINE__;

	rv = set_form_win (form, derw);
	if (rv != E_OK)
		throw __LINE__;

	rv = post_form (form);
	if (rv != E_OK)
		throw __LINE__;

	rv = wrefresh (form_win (form));
	if (rv != E_OK)
		throw __LINE__;

	step4 (form, Begin, End, fieldcontents);

	rv = unpost_form (form);
	if (rv != E_OK)
		throw __LINE__;

}

void step2 (vector<string> &attributes, VVSCI &Begin, VVSCI &End)
{
	int rv;
	WINDOW *mainwin = newwin (0, 0, 0, 0);
	if (! mainwin)
		throw __LINE__;

	rv = mvwaddstr (mainwin, LINES -1 , 0, 
		"forms/ncurses test. WARNING THIS PROGRAM LEAKS MEMORY.");
	if (rv != E_OK)
		throw __LINE__;
	rv = wrefresh (mainwin);
	if (rv != E_OK)
		throw __LINE__;
//	WINDOW *derw = derwin (mainwin, 0, 0, 1, 0);
	WINDOW *derw = derwin (mainwin, LINES - 2, 0, 1, 0);
//	WINDOW *derw = mainwin;
	if (! derw)
		throw __LINE__;
	wrefresh (derw);

	step3 (attributes, Begin, End, derw);

	delwin (derw);
	delwin (mainwin);

}

void step1 (vector<string> &attributes, VVSCI &Begin, VVSCI &End)
{
	initscr ();
	if (has_colors ()) {
		start_color ();
//		use_default_colors ();
		init_pair (2, COLOR_WHITE, COLOR_RED);
		init_pair (3, COLOR_WHITE, COLOR_BLUE);
	} else {
// throw __LINE__;
		clog << "not having colors...." << endl;
	}
//	trace (TRACE_CALLS);
	cbreak ();
	noecho ();
	keypad (stdscr, TRUE);
	clog << "LINES = " << LINES << endl;
	clog << "COLS  = " << COLS << endl;

	try {
		step2 (attributes, Begin, End);
	} catch (int line) {
		endwin ();
		cout << "cuaght exception in line " << line << endl;
	}

	endwin ();
}

void display_curses (VVS &v)
{
	VS attributes (* v.begin ());
	VVS::const_iterator Begin (v.begin () + 1);
	VVS::const_iterator End (v.end ());

	step1 (attributes, Begin, End);
}

void usage ()
{
	cerr << "usage: main <number of rows (> 2)>" << endl;
	exit (0);
}

int main (int argc, char **argv)
{
	int nrows;
	if (argc != 2) {
		cerr << "no argument specified, using 250" << endl;
		nrows = 250;
		sleep (3);
	} else
		nrows = atoi (argv [1]);
	if (nrows < 2)
		usage ();
//	setlocale (LC_ALL, "de_DE");
//	ofstream logfile("logfile");
	ofstream logfile("/dev/null");
	clog = logfile;

	vector<string> row;
	vector<vector<string > > vvs;
	for (int i = 0; i < nrows; ++i)
		row.push_back ("attribute");

	vvs.push_back (row);
	vvs.push_back (row);

	display_curses (vvs);
	return 0;
}

